#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char* argv[]){

	int count=0,i,j,non_violated_pairs = 0, total_pairs;
	float *model_values, *exp_values;
	char str[50];
	float c_ratio;
	FILE *data_file;

	if (argc < 2) {
		printf("USAGE: ");	
		printf("calc_correlation <data_file>");
		exit(1);
	}
	data_file = fopen(argv[1], "r");
	if (data_file == NULL) {
		printf("Error opening the file %s",argv[1]);
		exit(1);
	}	

	while(fgets(str,50,data_file)!=NULL) 
		count++;

	model_values = (float *)malloc(count * sizeof(float));
	exp_values = (float *)malloc(count * sizeof(float));

	count = 0;
	rewind(data_file);
	while (fscanf(data_file,"%f %f",&exp_values[count],&model_values[count])!=EOF)
		count++;
	fclose(data_file);

	total_pairs = (count * (count-1)) / 2;
	printf("The values read from the file\n");
	for (i=0;i<count;i++) 
		printf("%f %f\n",exp_values[i],model_values[i]);

	for (i=0;i<count;i++) {
		for (j=i+1;j<count;j++) {
			if ( ((model_values[i]-model_values[j]) * (exp_values[i]-exp_values[j])) > 0)	
				non_violated_pairs ++;	
		}
	}

	c_ratio = (float)non_violated_pairs / (float)total_pairs;

	printf("Correlation ratio is %f\n", c_ratio);
	
	free(model_values);
	free(exp_values);
	return 0;
}
