clear all;
clc;
gamma=[-1 0.00 0.261 0.466 0.701 0.996 1.232];
rents_para = textread('rent_mcnc20.txt','%f');
no_2LUTS = textread('no_2luts.txt','%d');
depth_2LUTS = textread('depth_2luts.txt','%d');
graph_point = 1;
modeled_wirelength = zeros(1,20);
modeled_cp_delay = zeros(1,20);
t_inter = 1.0;
t_intra = 0.1;
for n=10
     for k=2:7              
            i_cap= ceil((k/2)*(n+1));              %[7 8 10 12 14 16 18 20 22 24 26 28 30 32 34 36 38 39] 
            for bench=1:20    
            p = rents_para(bench);
            n2 = no_2LUTS(bench);
            d2 = depth_2LUTS(bench);
            nk= n2 * ((3/(k+1-gamma(k)))^(1/p));
            dk = (2 * d2) / (k-1-gamma(k) + log2(k-gamma(k)));
            f_max = round (((i_cap+n)*nk*(1-p))/n)^(1/(3-p));
            phi=0;
            for ni=1:f_max
                phi = phi + ( (ni^p) / ((ni^2)*(ni+1)) );
            end
            f_avg = ( (1-((f_max + 1)^(p - 1))) /(1 - ((f_max+1)^(p-2)) - (phi)) ) - 1;
            c = ((i_cap * (1+(1/f_avg)))/(k + 1 - gamma(k)))^(1/p);
            scp = ( (c-1) + ((c/nk)*((c*(k-gamma(k))) - c +1)) ) / (c*(k-gamma(k)));
            dc = dk * (1 - scp);
            cp_delay = (dc * t_inter) + (dk * t_intra);
            modeled_cp_delay(graph_point) = modeled_cp_delay(graph_point) + cp_delay;
            %nc_condition = ((n^p)*(k+1-gamma(k))) / (1+(1/f_avg));
            %if (i_cap < nc_condition)                          % I limited Architecture
                nc = n2 * ((3/(i_cap * (1+(1/f_avg))))^(1/p));
            %else                                               % N limited Architecture
            %   nc = (n2/n) * ((3/(k+1-gamma(k)))^(1/p));
            %end
            %wL_2p = ( ((p-0.5)/p) - sqrt(nc) - ((p-0.5)/(6*sqrt(nc)*(p+0.5))) + ((-p-1 + ((4^(p-0.5)))*(nc^p))/(2*p*(p+0.5)*(p-1))) ) ...
            %        / (1 + ( ((-2*p)-1+(2^(2*p-1)))*(nc^(p-0.5))/(2*p*(p-1)*(2*p-3)) ) - ((p-0.5)/(6*p*sqrt(nc))) - ((p-0.5)*sqrt(nc)/(p-1)) )
            wL_2p = ( 2*sqrt(2)*(3 + 3*p) * (nc ^ (p-0.5)) ) / ((1+2*p)*(2 + 2*p));
            wL = (wL_2p * 4* f_avg) / (3 + f_avg);
            modeled_wirelength(graph_point) = modeled_wirelength(graph_point) + wL;
            end
            graph_point = graph_point +1;     
    end
end
modeled_cp_delay(graph_point) = modeled_cp_delay(graph_point) / 20;
modeled_wirelength = modeled_wirelength / 20;
modeled_energy = (modeled_cp_delay .* modeled_wirelength);
x_axis_values =[7 8 10 12 14 16 18 20 22 24 26 28 30 32 34 36 38 39];
%plot(x_axis_values,modeled_wirelength(1:14));
%plot(x_axis_values,modeled_cp_delay(1:14));
plot(x_axis_values,modeled_energy(1:18));